set linesize 32000
set pagesize 1000
set long 2000000000
set longchunksize 1000
set echo on
set termout on
set trimspool on

spool functionbased4.log

select * from v$version;

drop table RTD_DOCUMENT;

CREATE TABLE RTD_DOCUMENT
(
  DOCUMENTID          NUMBER(19)                NOT NULL,
  DOCUMENTDATE        DATE                      DEFAULT sysdate               NOT NULL,
  CUSTOMERKEY         NUMBER(8),
  DOCUMENTNBR         NUMBER(10),
  CONSTRAINT RTD_DOCUMENT_PK
 PRIMARY KEY
 (DOCUMENTID)
)
ORGANIZATION INDEX;

CREATE INDEX RTD_DOCUMENT_IX_DOCDATE ON RTD_DOCUMENT
(DOCUMENTDATE, CUSTOMERKEY);

drop sequence testseq;
create sequence testseq;

insert into RTD_DOCUMENT 
select testseq.nextval,
to_date('10/02/2009','MM/DD/YYYY'),
90467978,
1
from dba_objects
where rownum < 11;

commit;

insert into RTD_DOCUMENT 
select testseq.nextval,
to_date('10/02/2009','MM/DD/YYYY'),
11111111,
1
from dba_objects;

insert into RTD_DOCUMENT 
select testseq.nextval,
to_date('10/02/2009','MM/DD/YYYY'),
99999999,
1
from dba_objects;

commit;

execute dbms_stats.gather_table_stats(NULL,'RTD_DOCUMENT');

alter session set nls_date_format='MM/DD/YYYY HH24:MI:SS';

set autotrace on

select /*+ index(d RTD_DOCUMENT_IX_DOCDATE) */
d.*
from RTD_document d
where CustomerKey like '90467978%' and
DocumentDate >= '10/01/2009 00:00:00'  and
DocumentDate <= '11/01/2009 00:00:00'  
order by  d.DocumentId desc;

set autotrace off

create index RTD_func_i on RTD_document (to_char(CustomerKey));

set autotrace on

select /*+ index(d RTD_DOCUMENT_IX_DOCDATE) */
d.*
from RTD_document d
where CustomerKey like '90467978%' and
DocumentDate >= '10/01/2009 00:00:00'  and
DocumentDate <= '11/01/2009 00:00:00'  
order by  d.DocumentId desc;

set autotrace off

spool off
